<template>
  <svn-pro-card
    color="surface"
    :width="128"
    :elevation="2"
    :disabled="state === 'not_started'"
    :link="state !== 'not_started'"
  >
    <div class="w-[128px] flex flex-col justify-center items-center p-4 gap-2">
      <svn-pro-text subtitle-large bold color="onSurface">
        {{ getBadgeCount() }}
      </svn-pro-text>

      <v-img
        class="w-16 h-16"
        cover
        :src="getBadge()"
      />

      <div
        class="w-full flex flex-col justify-center items-center"
        :class="state === 'in_progress' ? 'min-h-12 h-auto' : 'h-12'"
      >
        <div
          class="w-full flex items-center justify-center h-3"
          v-if="state === 'in_progress'"
        >
          <svn-pro-progress-linear :model-value="calculateProgress()" />
        </div>

        <svn-pro-text caption color="onSurface" class="text-center">
          {{ getBadgeCaption() }}
        </svn-pro-text>
      </div>
    </div>
  </svn-pro-card>
</template>

<script setup>
import { computed } from 'vue';
import SvnProCard from '../../components/card/SvnProCard.vue';
import SvnProText from '../../components/styles/SvnProText.vue';
import SvnProProgressLinear from '../../components/progress/SvnProProgressLinear.vue';
import TrainingCompleted from '../../assets/badge_book.svg';
import TrainingInProgress from '../../assets/training_in_progress.svg';
import TrainingNotStarted from '../../assets/training_not_started.svg';
import ModuleCompleted from '../../assets/badge_puzzle.svg';
import ModuleInProgress from '../../assets/module_in_progress.svg';
import ModuleNotStarted from '../../assets/module_not_started.svg';
import LikeCompleted from '../../assets/badge_heart.svg';
import LikeInProgress from '../../assets/like_in_progress.svg';
import LikeNotStarted from '../../assets/like_not_started.svg';
import ReactionCompleted from '../../assets/badge_thumb.svg';
import ReactionInProgress from '../../assets/reaction_in_progress.svg';
import ReactionNotStarted from '../../assets/reaction_not_started.svg';

const props = defineProps({
  count: {
    type: Number,
    default: undefined,
  },
  badgeType: {
    type: String,
    default: "training",
  },
  levels: {
    type: Object,
    default: () => {}
  }
})

const levelCaps = {
  training: {
    levelOne: 1,
    levelTwo: 3,
    levelThree: 5,
    levelFour: 20,
    titleOne: "Accomplished Apprentice",
    titleTwo: "Trained and Competent",
    titleThree: "Certified Expert",
    titleFour: "Training Champion",
  },
  module: {
    levelOne: 1,
    levelTwo: 5,
    levelThree: 10,
    levelFour: 25,
    titleOne: "Enlightened Novice",
    titleTwo: "Knowledge Explorer",
    titleThree: "Thirsty for Knowledge",
    titleFour: "Curriculum Master",
  },
  like: {
    levelOne: 1,
    levelTwo: 5,
    levelThree: 10,
    levelFour: 25,
    titleOne: "The Selector",
    titleTwo: "Content Lover",
    titleThree: "Informed Collector",
    titleFour: "Resource Guardian",
  },
  reaction: {
    levelOne: 1,
    levelTwo: 5,
    levelThree: 15,
    levelFour: 30,
    titleOne: "The Approver",
    titleTwo: "Positive Supporter",
    titleThree: "Enlightened Evaluator",
    titleFour: "Master of Emotions",
  },
}

const badges = {
  training: {
    completed: TrainingCompleted,
    in_progress: TrainingInProgress,
    not_started: TrainingNotStarted,
  },
  module: {
    completed: ModuleCompleted,
    in_progress: ModuleInProgress,
    not_started: ModuleNotStarted,
  },
  like: {
    completed: LikeCompleted,
    in_progress: LikeInProgress,
    not_started: LikeNotStarted,
  },
  reaction: {
    completed: ReactionCompleted,
    in_progress: ReactionInProgress,
    not_started: ReactionNotStarted,
  },
}

const state = computed(() => {
  if (props.count < props?.levels["levelOne"]) {
    return "not_started"
  } else if (props.count === props?.levels["levelOne"] || props.count === props?.levels["levelTwo"] || props.count === props?.levels["levelThree"] || props.count === props?.levels["levelFour"]) {
    return "completed"
  } else if (props.count > props?.levels["levelOne"] && props.count <= props?.levels["levelTwo"]) {
    return "in_progress"
  } else if (props.count > props?.levels["levelTwo"] && props.count <= props?.levels["levelThree"]) {
    return "in_progress"
  } else if (props.count > props?.levels["levelThree"] && props.count <= props?.levels["levelFour"]) {
    return "in_progress"
  } else if (props.count >= props?.levels["levelFour"]) {
    return "completed"
  }
})

const calculateCountValue = (type) => {
  if (props.count <= levelCaps[type]["levelOne"]) {
    return props.count
  } else if (props.count === levelCaps[type]["levelOne"] || props.count === levelCaps[type]["levelTwo"] || props.count === levelCaps[type]["levelThree"] || props.count === levelCaps[type]["levelFour"]) {
    return props.count
  } else if (props.count > levelCaps[type]["levelOne"] && props.count <= levelCaps[type]["levelTwo"]) {
    return `${props.count}/${levelCaps[type]["levelTwo"]}`
  } else if (props.count > levelCaps[type]["levelTwo"] && props.count <= levelCaps[type]["levelThree"]) {
    return `${props.count}/${levelCaps[type]["levelThree"]}`
  } else if (props.count > levelCaps[type]["levelThree"] && props.count <= levelCaps[type]["levelFour"]) {
    return `${props.count}/${levelCaps[type]["levelFour"]}`
  } else if (props.count >= levelCaps[type]["levelFour"]) {
    return levelCaps[type]["levelFour"]
  }
}

const calculateProgressValue = (type) => {
  if (props.count <= levelCaps[type]["levelOne"]) {
    return props.count
  } else if (props.count === levelCaps[type]["levelOne"] || props.count === levelCaps[type]["levelTwo"] || props.count === levelCaps[type]["levelThree"] || props.count === levelCaps[type]["levelFour"]) {
    return props.count
  } else if (props.count > levelCaps[type]["levelOne"] && props.count <= levelCaps[type]["levelTwo"]) {
    return (props.count / levelCaps[type]["levelTwo"]) * 100
  } else if (props.count > levelCaps[type]["levelTwo"] && props.count <= levelCaps[type]["levelThree"]) {
    return (props.count / levelCaps[type]["levelThree"]) * 100
  } else if (props.count > levelCaps[type]["levelThree"] && props.count <= levelCaps[type]["levelFour"]) {
    return (props.count / levelCaps[type]["levelFour"]) * 100
  } else if (props.count >= levelCaps[type]["levelFour"]) {
    return levelCaps[type]["levelFour"]
  }
}

const calculateStateValue = (type) => {
  if (state?.value === "completed") {
    return badges[type]["completed"]
  } else if (state?.value === "in_progress") {
    return badges[type]["in_progress"]
  } else if (state?.value === "not_started") {
    return badges[type]["not_started"]
  }
}

const getBadgeCount = () => {
  switch (props.badgeType) {
    case "training":
      return calculateCountValue("training")
    case "module":
      return calculateCountValue("module")
    case "like":
      return calculateCountValue("like")
    case "reaction":
      return calculateCountValue("reaction")
    default:
      return ""
  }
}

const getBadge = () => {
  switch (props.badgeType) {
    case "training":
      return calculateStateValue("training")
    case "module":
      return calculateStateValue("module")
    case "like":
      return calculateStateValue("like")
    case "reaction":
      return calculateStateValue("reaction")
    default:
      return ""
  }
}

const calculateProgress = () => {
  switch (props.badgeType) {
    case "training":
      return calculateProgressValue("training")
    case "module":
      return calculateProgressValue("module")
    case "like":
      return calculateProgressValue("like")
    case "reaction":
      return calculateProgressValue("reaction")
    default:
      return ""
  }
}

const getBadgeCaption = () => {
  if (props.count <= levelCaps[props.badgeType]["levelOne"]) {
    return levelCaps[props.badgeType]["titleOne"]
  } else if (props.count === levelCaps[props.badgeType]["levelTwo"]) {
    return levelCaps[props.badgeType]["titleTwo"]
  } else if (props.count === levelCaps[props.badgeType]["levelThree"]) {
    return levelCaps[props.badgeType]["titleThree"]
  } else if (props.count === levelCaps[props.badgeType]["levelFour"]) {
    return levelCaps[props.badgeType]["titleFour"]
  } else if (props.count > levelCaps[props.badgeType]["levelOne"] && props.count <= levelCaps[props.badgeType]["levelTwo"]) {
    return levelCaps[props.badgeType]["titleOne"]
  } else if (props.count > levelCaps[props.badgeType]["levelTwo"] && props.count <= levelCaps[props.badgeType]["levelThree"]) {
    return levelCaps[props.badgeType]["titleTwo"]
  } else if (props.count > levelCaps[props.badgeType]["levelThree"] && props.count <= levelCaps[props.badgeType]["levelFour"]) {
    return levelCaps[props.badgeType]["titleThree"]
  } else if (props.count >= levelCaps[props.badgeType]["levelFour"]) {
    return levelCaps[props.badgeType]["titleFour"]
  }
}
</script>

<style scoped>
.cardShadow {
  box-shadow: 0px 2px 2px 0px rgba(0, 0, 0, 0.14), 0px 3px 1px 0px rgba(0, 0, 0, 0.12), 0px 1px 5px 0px rgba(0, 0, 0, 0.20);
}
</style>